<div class="column" align="middle">
  <a href="https://github.com/matrixorigin/matrixone/blob/main/LICENSE">
    <img src="https://img.shields.io/badge/License-Apache%202.0-red.svg" alt="license"/>
  </a>
  <a href="https://golang.org/">
    <img src="https://img.shields.io/badge/Language-Go-blue.svg" alt="language"/>
  </a>
  <img src="https://img.shields.io/badge/platform-MacOS-white.svg" alt="macos"/>
  <img src="https://img.shields.io/badge/platform-Linux-9cf.svg" alt="linux"/>
  <a href="https://www.codefactor.io/repository/github/matrixorigin/matrixone">
    <img src="https://www.codefactor.io/repository/github/matrixorigin/matrixone/badge?s=7280f4312fca2f2e6938fb8de5b726c5252541f0" alt="codefactor"/>
  </a>
  <a href="https://docs.matrixorigin.io/0.3.0/MatrixOne/Release-Notes/v0.3.0/">
   <img src="https://img.shields.io/badge/Release-v0.3.0-green.svg" alt="release"/>
  </a>
  <br>
  <a href="https://docs.matrixorigin.io/0.3.0/">
    <b>Docs</b>
  </a>
  <b>||</b>
  <a href="https://www.matrixorigin.io/">
   <b> Official Website</b>
  </a>
  <br>
  <a href="https://github.com/matrixorigin/matrixone/blob/main/README.md">
    <b>English</b>
  </a>
  <b>||</b>
  <a href="https://github.com/matrixorigin/matrixone/blob/main/README_CN.md">
    <b>简体中文</b>
  </a>
</div>


<h3 align="center">Connect with us:</h3>
<p align="center">
<a href="https://twitter.com/matrixone16" target="blank"><img align="center" src="https://raw.githubusercontent.com/rahuldkjain/github-profile-readme-generator/master/src/images/icons/Social/twitter.svg" alt="matrixone16" height="30" width="40" /></a>
<a href="http://matrixoneworkspace.slack.com" target="blank"><img align="center" src="https://github.com/dengn/CASAUVSQ/blob/priority/slack_icon.png" alt="matrixone16" height="30" width="30" /></a>

</p>

<h5 align="center">If you are interested in MatrixOne project, please kindly give MatrixOne a triple `Star`, `Fork` and `Watch`, Thanks!</h5>




Contents
========

* [What is MatrixOne](#what-is-matrixone)
* [KeyFeatures](#key-features)
* [User Values](#user-values)
* [Architecture](#architecture)
* [Quick start](#quick-start)
* [Contributing](#contributing)
* [License](#license)

## What is MatrixOne?



MatrixOne is a future-oriented hyper-converged cloud and edge native DBMS that supports transactional, analytical, and streaming workloads with a simplified and distributed database engine, across multiple data centers, clouds, edges and other heterogeneous infrastructures.


##  🎯 <a id="key-features">Key Features</a> 
### 💥 **Hyper-converged Engine**

<details>
  <summary><b><font size=4>Monolithic Engine</b></font></summary> 
          A monolithic database engine is designed to support hybrid workloads: transactional, analytical, streaming, time-series, machine learning, etc.
</details>

<details>
  <summary><b><font size=4>Built-in Streaming Engine</b></font></summary> 
               With the built-in streaming engine, MatrixOne supports in-database streaming processing by groundbreaking incremental materialized view maintenance.
</details>


### ☁️ **Cloud & Edge Native**

<details>
  <summary><b><font size=4>Real Infrastructure Agnostic</b></font></summary> 
               MatrixOne supports seemless workload migration and bursting among different locations and infrastructures.
</details>

<details>
  <summary><b><font size=4>Multi-site Active/Active</b></font></summary> 
                    MatrixOne provides industry-leading latency control with optimized consistency protocol.
</details>

### 🚀 **Extreme Performance**

<details>
  <summary><b><font size=4>High Performance</b></font></summary> 
     Accelerated queries supported by patented vectorized execution as well as optimal computation push down strategies through factorization techniques.
</details>

<details>
  <summary><b><font size=4>Strong Consistency</b></font></summary> 
     MatrixOne introduces a global, high-performance distributed transaction protocol across storage engines.
</details>

<details>
  <summary><b><font size=4>High Scalability</b></font></summary> 
     Seamless and non-disruptive scaling by disaggregated storage and compute.   
</details>

## 💎 **<a id="user-values">User Values</a>**
<details>
  <summary><b><font size=4>Simplify Database Management and Maintenance</b></font></summary> 
     To solve the problem of high and unpredictable cost of database selection process, management and maintenance due to database overabundance, MatrixOne all-in-one architecture will significantly simplify database management and maintenance, single database can serve multiple data applications.
</details>
<details>
  <summary><b><font size=4>Reduce Data Fragmentation and Inconsistency</b></font></summary>
     Data flow and copy between different databases makes data sync and consistency increasingly difficult. The unified incrementally materialized view of MatrixOne makes the downstream can support real-time upstream update, achieve the end-to-end data processing without redundant ETL process.
</details>
<details>
  <summary><b><font size=4>Decoupling Data Architecture From Infrastructure</b></font></summary>
     Currently the architecture design across different infrastructures is complicated, causes new data silos between cloud and edge, cloud and on-premise. MatrixOne is designed with unified architecture to support simplified data management and operations across different type of infrastructures.
</details>
<details>
  <summary><b><font size=4>Extremely Fast Complex Query Performance</b></font></summary>  
     Poor business agility as a result of slow complex queries and redundant intermediate tables in current data warehousing solutions. MatrixOne  supports blazing fast experience even for star and snowflake schema queries, improving business agility by real-time analytics.
</details>
<details>
  <summary><b><font size=4>A Solid OLTP-like OLAP Experience</b></font></summary>   
     Current data warehousing solutions have the following problems such as high latency and absence of immediate visibility for data updates. MatrixOne brings OLTP (Online Transactional Processing) level consistency and high availability to CRUD operations in OLAP (Online Analytical Processing).
</details>
<details>
  <summary><b><font size=4>Seamless and Non-disruptive Scalability</b></font></summary>   
     It is difficult to balance performance and scalability to achieve optimum price-performance ratio in current data warehousing solutions. MatrixOne's disaggregated storage and compute architecture makes it fully automated and efficient scale in/out and up/down without disrupting applications.
</details>

<br>


## 🔎 <a id="architecture">Architecture</a>
MatrixOne's architecture is as below:   
<p align="center">
  <img alt="MatrixOne" height="500" width="700" src="https://github.com/matrixorigin/artwork/blob/main/docs/overview/overall-architecture.png?raw=true">
</p>

For more details, you can checkout [MatrixOne Architecture](https://docs.matrixorigin.io/0.3.0/MatrixOne/Overview/matrixone-architecture/) and [MatrixOne Tech Design](https://docs.matrixorigin.io/0.3.0/MatrixOne/Overview/MatrixOne-Tech-Design/matrixone-techdesign/).


## ⚡️ <a id="quick-start">Quick start</a>


### ⚙️ Install MatrixOne
MatrixOne supports Linux and MacOS. You can install MatrixOne either by [building from source](#building-from-source) or [using docker](#using-docker).
For other installation types, please refer to [MatrixOne installation](https://docs.matrixorigin.io/0.3.0/MatrixOne/Get-Started/install-standalone-matrixone/) for more details.
#### **Building from source**

1. Install Go (version 1.18 is required).
  
2. Get the MatrixOne code:

```
$ git clone https://github.com/matrixorigin/matrixone.git
$ cd matrixone
```

3. Run make:

You can run `make debug`, `make clean`, or anything else our Makefile offers.

```
$ make config
$ make build
```

4. Boot MatrixOne server:

```
$ ./mo-server system_vars_config.toml
```


#### **Using docker**
1. Make sure Docker is installed, verify Docker daemon is running in the background:

```
$ docker --version
```

2. Create and run the container for the latest release of MatrixOne. It will pull the image from Docker Hub if not exists.
   
```
$ docker run -d -p 6001:6001 --name matrixone matrixorigin/matrixone:latest
```

### 🌟 Connecting to MatrixOne server

1. Install MySQL client.
   
   MatrixOne supports the MySQL wire protocol, so you can use MySQL client drivers to connect from various languages. Currently, MatrixOne is only compatible with Oracle MySQL client. This means that some features might not work with MariaDB client.

2. Connect to MatrixOne server:

```
$ mysql -h IP -P PORT -uUsername -p
```
   The connection string is the same format as MySQL accepts. You need to provide a user name and a password. 

   Use the built-in test account for example:

   - user: dump
   - password: 111

```
$ mysql -h 127.0.0.1 -P 6001 -udump -p
Enter password:
```

Now, MatrixOne only supports the TCP listener. 




## 🙌 <a id="contributing">Contributing</a>

Contributions to MatrixOne are welcome from everyone.  
 See [Contribution Guide](https://docs.matrixorigin.io/0.3.0/MatrixOne/Contribution-Guide/make-your-first-contribution/) for details on submitting patches and the contribution workflow. 

### 👏 All contributors

<!-- readme: contributors -start -->
<table>
<tr>
    <td align="center">
        <a href="https://github.com/XuPeng-SH">
            <img src="https://avatars.githubusercontent.com/u/39627130?v=4" width="30;" alt="XuPeng-SH"/>
            <br />
            <sub><b>XuPeng-SH</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/nnsgmsone">
            <img src="https://avatars.githubusercontent.com/u/31609524?v=4" width="30;" alt="nnsgmsone"/>
            <br />
            <sub><b>Nnsgmsone</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/daviszhen">
            <img src="https://avatars.githubusercontent.com/u/60595215?v=4" width="30;" alt="daviszhen"/>
            <br />
            <sub><b>Daviszhen</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/dengn">
            <img src="https://avatars.githubusercontent.com/u/4965857?v=4" width="30;" alt="dengn"/>
            <br />
            <sub><b>Dengn</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/aunjgr">
            <img src="https://avatars.githubusercontent.com/u/523063?v=4" width="30;" alt="aunjgr"/>
            <br />
            <sub><b>BRong Njam</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/sukki37">
            <img src="https://avatars.githubusercontent.com/u/77312370?v=4" width="30;" alt="sukki37"/>
            <br />
            <sub><b>Maomao</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/zzl200012">
            <img src="https://avatars.githubusercontent.com/u/57308069?v=4" width="30;" alt="zzl200012"/>
            <br />
            <sub><b>Kutori</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/lignay">
            <img src="https://avatars.githubusercontent.com/u/58507761?v=4" width="30;" alt="lignay"/>
            <br />
            <sub><b>Matthew</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/m-schen">
            <img src="https://avatars.githubusercontent.com/u/59043531?v=4" width="30;" alt="m-schen"/>
            <br />
            <sub><b>Chenmingsong</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/jiangxinmeng1">
            <img src="https://avatars.githubusercontent.com/u/51114574?v=4" width="30;" alt="jiangxinmeng1"/>
            <br />
            <sub><b>Jiangxinmeng1</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/JinHai-CN">
            <img src="https://avatars.githubusercontent.com/u/33142505?v=4" width="30;" alt="JinHai-CN"/>
            <br />
            <sub><b>Jin Hai</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/LeftHandCold">
            <img src="https://avatars.githubusercontent.com/u/14086886?v=4" width="30;" alt="LeftHandCold"/>
            <br />
            <sub><b>GreatRiver</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/reusee">
            <img src="https://avatars.githubusercontent.com/u/398457?v=4" width="30;" alt="reusee"/>
            <br />
            <sub><b>Reusee</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/broccoliSpicy">
            <img src="https://avatars.githubusercontent.com/u/93440049?v=4" width="30;" alt="broccoliSpicy"/>
            <br />
            <sub><b>BroccoliSpicy</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/iamlinjunhong">
            <img src="https://avatars.githubusercontent.com/u/49111204?v=4" width="30;" alt="iamlinjunhong"/>
            <br />
            <sub><b>Iamlinjunhong</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/wanhanbo">
            <img src="https://avatars.githubusercontent.com/u/97089788?v=4" width="30;" alt="wanhanbo"/>
            <br />
            <sub><b>Wanhanbo</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/w-zr">
            <img src="https://avatars.githubusercontent.com/u/28624654?v=4" width="30;" alt="w-zr"/>
            <br />
            <sub><b>Wei Ziran</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/jianwan0214">
            <img src="https://avatars.githubusercontent.com/u/32733096?v=4" width="30;" alt="jianwan0214"/>
            <br />
            <sub><b>Jianwan0214</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/wanglei4687">
            <img src="https://avatars.githubusercontent.com/u/74483764?v=4" width="30;" alt="wanglei4687"/>
            <br />
            <sub><b>Wanglei</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/fengttt">
            <img src="https://avatars.githubusercontent.com/u/169294?v=4" width="30;" alt="fengttt"/>
            <br />
            <sub><b>Fengttt</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/lni">
            <img src="https://avatars.githubusercontent.com/u/30930154?v=4" width="30;" alt="lni"/>
            <br />
            <sub><b>Lni</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/zhangxu19830126">
            <img src="https://avatars.githubusercontent.com/u/2995754?v=4" width="30;" alt="zhangxu19830126"/>
            <br />
            <sub><b>Fagongzi</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/qingxinhome">
            <img src="https://avatars.githubusercontent.com/u/70939751?v=4" width="30;" alt="qingxinhome"/>
            <br />
            <sub><b>Qingxinhome</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/ouyuanning">
            <img src="https://avatars.githubusercontent.com/u/45346669?v=4" width="30;" alt="ouyuanning"/>
            <br />
            <sub><b>Ouyuanning</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/yingfeng">
            <img src="https://avatars.githubusercontent.com/u/7248?v=4" width="30;" alt="yingfeng"/>
            <br />
            <sub><b>Yingfeng</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/noneback">
            <img src="https://avatars.githubusercontent.com/u/46670806?v=4" width="30;" alt="noneback"/>
            <br />
            <sub><b>NoneBack</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/WenhaoKong2001">
            <img src="https://avatars.githubusercontent.com/u/43122508?v=4" width="30;" alt="WenhaoKong2001"/>
            <br />
            <sub><b>Otter</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/aptend">
            <img src="https://avatars.githubusercontent.com/u/49832303?v=4" width="30;" alt="aptend"/>
            <br />
            <sub><b>Aptend</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/MatrixAdventurer">
            <img src="https://avatars.githubusercontent.com/u/85048713?v=4" width="30;" alt="MatrixAdventurer"/>
            <br />
            <sub><b>MatrixAdventurer</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/anitajjx">
            <img src="https://avatars.githubusercontent.com/u/61374486?v=4" width="30;" alt="anitajjx"/>
            <br />
            <sub><b>Anitajjx</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/whileskies">
            <img src="https://avatars.githubusercontent.com/u/20637002?v=4" width="30;" alt="whileskies"/>
            <br />
            <sub><b>Whileskies</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/BePPPower">
            <img src="https://avatars.githubusercontent.com/u/43782773?v=4" width="30;" alt="BePPPower"/>
            <br />
            <sub><b>BePPPower</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/jiajunhuang">
            <img src="https://avatars.githubusercontent.com/u/5924269?v=4" width="30;" alt="jiajunhuang"/>
            <br />
            <sub><b>Jiajun Huang</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/NTH19">
            <img src="https://avatars.githubusercontent.com/u/74389817?v=4" width="30;" alt="NTH19"/>
            <br />
            <sub><b>NTH19</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/Y7n05h">
            <img src="https://avatars.githubusercontent.com/u/69407218?v=4" width="30;" alt="Y7n05h"/>
            <br />
            <sub><b>Y7n05h</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/decster">
            <img src="https://avatars.githubusercontent.com/u/193300?v=4" width="30;" alt="decster"/>
            <br />
            <sub><b>Binglin Chang</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/JackTan25">
            <img src="https://avatars.githubusercontent.com/u/60096118?v=4" width="30;" alt="JackTan25"/>
            <br />
            <sub><b>Boyu Tan</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/Charlie17Li">
            <img src="https://avatars.githubusercontent.com/u/32014420?v=4" width="30;" alt="Charlie17Li"/>
            <br />
            <sub><b>Charlie17Li</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/domingozhang">
            <img src="https://avatars.githubusercontent.com/u/88298673?v=4" width="30;" alt="domingozhang"/>
            <br />
            <sub><b>DomingoZhang</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/Fungx">
            <img src="https://avatars.githubusercontent.com/u/38498093?v=4" width="30;" alt="Fungx"/>
            <br />
            <sub><b>Fungx</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/JasonPeng1310">
            <img src="https://avatars.githubusercontent.com/u/46837930?v=4" width="30;" alt="JasonPeng1310"/>
            <br />
            <sub><b>Jason Peng</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/ikenchina">
            <img src="https://avatars.githubusercontent.com/u/3422667?v=4" width="30;" alt="ikenchina"/>
            <br />
            <sub><b>O2</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/RinChanNOWWW">
            <img src="https://avatars.githubusercontent.com/u/33975039?v=4" width="30;" alt="RinChanNOWWW"/>
            <br />
            <sub><b>RinChanNOW!</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/chaixuqing">
            <img src="https://avatars.githubusercontent.com/u/41991639?v=4" width="30;" alt="chaixuqing"/>
            <br />
            <sub><b>XuQing Chai</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/yuxubinchen">
            <img src="https://avatars.githubusercontent.com/u/74901886?v=4" width="30;" alt="yuxubinchen"/>
            <br />
            <sub><b>ZeYu Zhao</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/adlternative">
            <img src="https://avatars.githubusercontent.com/u/58138461?v=4" width="30;" alt="adlternative"/>
            <br />
            <sub><b>ZheNing Hu</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/ajian2002">
            <img src="https://avatars.githubusercontent.com/u/37119488?v=4" width="30;" alt="ajian2002"/>
            <br />
            <sub><b>Ajian</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/bxiiiiii">
            <img src="https://avatars.githubusercontent.com/u/75570810?v=4" width="30;" alt="bxiiiiii"/>
            <br />
            <sub><b>Binxxi</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/coderzc">
            <img src="https://avatars.githubusercontent.com/u/26179648?v=4" width="30;" alt="coderzc"/>
            <br />
            <sub><b>Coderzc</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/e11jah">
            <img src="https://avatars.githubusercontent.com/u/30852919?v=4" width="30;" alt="e11jah"/>
            <br />
            <sub><b>e11jah</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/florashi181">
            <img src="https://avatars.githubusercontent.com/u/87641339?v=4" width="30;" alt="florashi181"/>
            <br />
            <sub><b>Florashi181</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/hiyoyolumi">
            <img src="https://avatars.githubusercontent.com/u/75571545?v=4" width="30;" alt="hiyoyolumi"/>
            <br />
            <sub><b>Hiyoyolumi</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/jinfuchiang">
            <img src="https://avatars.githubusercontent.com/u/92502624?v=4" width="30;" alt="jinfuchiang"/>
            <br />
            <sub><b>Jinfu</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/sundy-li">
            <img src="https://avatars.githubusercontent.com/u/3325189?v=4" width="30;" alt="sundy-li"/>
            <br />
            <sub><b>Sundyli</b></sub>
        </a>
    </td></tr>
<tr>
    <td align="center">
        <a href="https://github.com/supermario1990">
            <img src="https://avatars.githubusercontent.com/u/8428531?v=4" width="30;" alt="supermario1990"/>
            <br />
            <sub><b>Supermario1990</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/xiw5">
            <img src="https://avatars.githubusercontent.com/u/33027107?v=4" width="30;" alt="xiw5"/>
            <br />
            <sub><b>Xiyuedong</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/yclchuxue">
            <img src="https://avatars.githubusercontent.com/u/75575291?v=4" width="30;" alt="yclchuxue"/>
            <br />
            <sub><b>Yclchuxue</b></sub>
        </a>
    </td>
    <td align="center">
        <a href="https://github.com/ZtXavier">
            <img src="https://avatars.githubusercontent.com/u/75614614?v=4" width="30;" alt="ZtXavier"/>
            <br />
            <sub><b>Zt</b></sub>
        </a>
    </td></tr>
</table>
<!-- readme: contributors -end -->



## <a id="license">License</a>
MatrixOne is licensed under the [Apache License, Version 2.0](LICENSE).


