# **Types of Contributions**

Contributions to MatrixOne are not limited to writing code. What follows are different ways to participate in the MatrixOne project and engage with our vibrant open-source community:

## **Contribute Code**

| Contribution type              | Description                                                  |
| ------------------------------ | ------------------------------------------------------------ |
| Report a bug                   | To report a problem with MatrixOne, [file an issue](https://github.com/matrixorigin/matrixone/issues/new/choose) on GitHub. Include detailed information about the problem you've encountered. |
| Contribute code                | You can fix a bug for any outstanding [issues](https://github.com/matrixorigin/matrixone/issues) on GitHub, improve the code, or propose a design or implementation for a new MatrixOne feature. See [Contribute Code](contribute-code.md) for the contribution conventions and best practices. |
| Review or approve pull requests | Review or approve pull requests for the MatrixOne project as a reviewer or maintainer. |

## **Contribute to MatrixOne Documentation**

| Contribution type                             | Description                                                  |
| --------------------------------------------- | ------------------------------------------------------------ |
| Report or fix a technical documentation issue | You can either click *edit the page* directly on the target page of MatrixOne, or [file an issue](https://github.com/matrixorigin/matrixone/issues/new/choose) on MatrixOne repository with detailed information, and, if possible, propose changes by [creating a pull request](https://github.com/matrixorigin/matrixone/pulls). |
| Contribute a new piece of technical document  | Before contributing a full-length technical document, read [Contribution Documentation](contribute-documentation.md). |

## **Other Contributions**

| Contribution type                                 | Description                                                  |
| ------------------------------------------------- | ------------------------------------------------------------ |
| Share your demos and solutions                    | Show MatrixOne users how to leverage the platform in specific scenarios. Send your use case to dengnan@matrixorigin.io and we'll post it in the community. |
| Author a blog article, user story, or whitepapers | Write high-quality content that clearly and accurately explains technical details about MatrixOne. |
| Give a tech talk or host a live broadcast         | Give talks or host live broadcasts that help raise awareness around MatrixOne. |
| Support MatrixOne users                              | Help users on GitHub solve the problems they meet while using MatrixOne. |
| Issue triage                                      | Adding descriptive labels to our [GitHub issues](https://github.com/matrixorigin/matrixone/issues) speeds up routing issues to the right person in charge. It is a great contribution to the operation of the MatrixOne project. |
| Contribute otherwise                              | Any contribution that plays a positive role in the development of MatrixOne and its open-source community will be considered for eligibility. |
