# **MatrixOne Introduction** 

MatrixOne is a future-oriented hyperconverged cloud & edge native DBMS that supports transactional, analytical, and streaming workload with a simplified and distributed database engine, across multiple datacenters, clouds, edges and other heterogenous infrastructures.

## **Key Features** 
### **Hyperconverged Engine**
* **Monolitic Engine**
  
     A monolithic database engine is designed to support hybrid workloads: transactional, analytical, streaming, time-series, machine learning, etc.

* **Built-in Streaming Engine**
  
     With the built-in streaming engine, MatrixOne supports in-database streaming processing by groundbreaking incremental materialized view maintenance.

### **Cloud & Edge Native**
* **Real Infrastructure Agnostic**
  
     MatrixOne supports seemless workload migration and bursting among different locations and infrastructures.

* **Multi-site Active/Active**
  
     MatrixOne provides industry-leading latency control with optimized consistency protocol.

### **Extreme Performance**
* **High Performance**
  
     Accelerated queries supported by patented vectorized execution as well as optimal computation push down strategies through factorization techniques.

* **Strong Consistency**
  
     MatrixOne introduces a global, high-performance distributed transaction protocol across storage engines.

* **High Scalability**
  
     Seamless and non-disruptive scaling by disaggregated storage and compute.   

## **User Values**
* **Simplify Database Management and Maintenance**
  
     To solve the problem of high and unpredictable cost of database selection process, management & maintenance due to database overabundance, MatrixOne all-in-one architecture will significantly simplify database management and maintenance, single database can serve multiple data applications.

* **Reduce Data Fragmentation and Inconsistency**
  
     Data flow and copy between different databases makes data sync and consistency increasingly difficult. The unified incrementally materialized view of MatrixOne makes the downstream can support real-time upstream update, achieve the end-to-end data processing without redundant ETL process.

* **Decoupling Data Architecture From Infrastructure**
  
     Currently the architecture design across different infrastructures is complicated, causes new data silos between cloud and edge, cloud and on-premise.MatrixOne is designed with unified architecture to support simplified data management and operations across different type of infrastructures.

* **Extremely Fast Complex Query Performance**
  
     Poor business agility as a result of slow complex queries and redundant intermediate tables in current data warehousing solutions. MatrixOne  supports blazing fast experience even for star and snowflake schema queries, improving business agility by real-time analytics.
     
* **An Solid OLTP-like OLAP Experience**
  
     Current data warehousing solutions have the following problems such as high latency and absense of immediate visibility for data updates. MatrixOne brings OLTP (Online Transactional Processing) level consistency and high availability to CRUD operations in OLAP (Online Analytical Processing).

* **Seamless and Non-disruptive Scaling**
  
     It is difficult to balance performance and scalability to achieve optimum price-performance ratio in current data warehousing solutions. MatrixOne's disaggregated storage and compute architecture makes it fully automated and efficient scale in/out and up/down without disrupting applications.

## **Learn More**
This page outlines the overall introduction of MatrixOne. For information on other options that are available when you what to know more about MatrixOne product design, see the following:

* [MatrixOne Architecture](matrixone-architecture.md)
* [MatrixOne Tech Design](MatrixOne-Tech-Design/matrixone-techdesign.md)