// Copyright 2021 Matrix Origin
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package overload

import (
	"fmt"
	"github.com/matrixorigin/matrixone/pkg/container/types"
	"github.com/matrixorigin/matrixone/pkg/container/vector"
	"github.com/matrixorigin/matrixone/pkg/vm/process"
)

func MultiEval(op int, typ types.T, bs []bool, vecs []*vector.Vector, proc *process.Process) (*vector.Vector, error) {
	for i, vec := range vecs {
		if vector.Length(vec) == 1 {
			bs[i] = true
		}
	}
	if os, ok := MultiOps[op]; ok {
		for _, o := range os {
			if o.Typ == typ {
				return o.Fn(vecs, proc, bs)
			}
		}
	}
	return nil, fmt.Errorf("%s not yet implemented for %s", OpName[op], typ)
}

var MultiOps = map[int][]*MultiOp{}
